@use crate::templates::base;
@use crate::templates::labels;
@use crate::cat_page::CatPage;
@use rich_crate::Include;
@use crate::Urler;
@use crate::iter::*;

@(p: &CatPage, url: &Urler)

@:base(&p.page(), {
    <header id="category">
        <div class="inner-col">
            <div class="breadcrumbs" typeof="BreadcrumbList">
            <h1 role="banner">
              <span property="itemListElement" typeof="ListItem">
                <a property="item" typeof="WebPage" href="/"><span property="name">Crates</span>.rs</a>
                <meta property="position" content="1">
              </span>
            </h1>
            &rsaquo;
            <span property="itemListElement" typeof="ListItem">
              <a href="/#home-categories" property="item" typeof="WebPage"><span property="name">Categories</span></a>
              <meta property="position" content="2">
            </span>
            &rsaquo;
            <span class="categories has-keywords">
            @for (i, subcat) in p.parent_categories().iter().enumerate() {
                <span property="itemListElement" typeof="ListItem">
                  <a href="@url.category(subcat)" title="@subcat.short_description" property="item" typeof="WebPage"><span property="name">@subcat.name</span></a>
                  <meta property="position" content="@(i+3)">
                </span>
                &rsaquo;
            }
            </span>
            <span class="keywords">
              <span>
                @for key in p.keywords.iter().take(3) {
                  <a href="@url.keyword(key)" class=keyword><span>#</span>@key</a>
                }
              </span>
              @for key in p.keywords.iter().skip(3).take(3) {
                <a href="@url.keyword(key)" class=keyword><span>#</span>@key</a>
              }
            </span>

            <h2>@p.cat.name</h2>
            <p class=desc>@p.description()</p>
            </div>

            <nav><ul>
              <li class=active>@if p.crates.len() != p.count {
                    @p.crates.len() of @p.count crates
                } else {
                    @p.count crates
                }
              </li>
            </ul></nav>
        </div>
    </header>

    <main>
        @if p.has_subcategories_and_siblings() {
          <nav id="category-subcategories" role="navigation">
            <div class="inner-col">
              <ul>
                @for subcat in p.subcategories_and_siblings() {
                    <li><a href="@url.category(subcat)">
                      <div class=h>
                        <h4>@subcat.name</h4>
                        <p class=desc>@subcat.description</p>
                      </div>
                    </a></li>
                }
              </ul>
            </div>
          </nav>
          <hr>
        }

        <div id="category-crates" class="cat-@p.cat.slug">
          <div class="inner-col">
            <ul>
                @for (c, downloads) in &p.crates {
                <li>
                    <a href="@url.krate(c)">
                        <div class=h>
                            <h4>@c.short_name()</h4>
                            @if let Some(desc) = c.description() {
                              <p class=desc>@p.render_markdown_str(desc)</p>
                            }
                        </div>
                        <div class=meta>
                            <span class="version @p.version_class(c)"><span>v</span>@c.version()</span>
                            @if *downloads >= 100 {
                              <span class=downloads title="@downloads recent downloads">@if let Some((num,unit)) = Some(p.downloads(*downloads)) {@num<b>@unit</b>}</span>
                            }
                            @:labels(c, (false, false))
                            @for k in c.keywords(Include::Cleaned) {
                                <span class=k><span>#</span>@k</span>
                            }
                        </div>
                    </a>
                </li>
                }
            </ul>
          </div>
        </div>
    </main>
    <footer>
      @if let Some(related) = Some(p.related_categories()) {
      @if !related.is_empty() {
        <div class=seealso>
        <div class="inner-col" role="navigaton" aria-label="See also">
          See also:
            @for (last, cat) in related.iter().identify_last() {
            @for (last, subcat) in cat.iter().identify_last() {
              <a href="@url.category(subcat)" title="@subcat.short_description">@subcat.name</a>
              @if !last {&rsaquo;}
            }
            @if !last {|}
          }
        </div>
        </div>
      }
      }
      </footer>
})
